<template>
	<v-card class="pa-4 color" width="30vw" height="55vh">
		<h1 class="text-center mb-6 pieTitle">מבוקשים / חשודים</h1>
		<pie-chart ref="pieChart" :chartData="chartData" :options="options" />
	</v-card>
</template>

<script>
import PieChart from './PieChart';
import { mapGetters } from 'vuex';

export default {
	name: 'SuspectsWantedChart',
	components: { PieChart },
	data() {
		return {
			loaded: false,
			chartData: {
				labels: ['מבוקשים', 'חשודים'],
				datasets: [
					{
						label: 'גרף מבוקשים חשודים',
						data: [],
						backgroundColor: ['#f6a9fc', '#5e8b7e'],
					},
				],
			},
			options: {
				type: 'pie',
				maintainAspectRatio: false,
				tooltips: {
					callbacks: {
						label: function(tooltipItem, data) {
							return (
								data['labels'][tooltipItem['index']] +
								': ' +
								data['datasets'][0]['data'][tooltipItem['index']] +
								'%'
							);
						},
					},
				},
				legend: {
					position: 'left',
					align: 'center',
					rtl: true,
					labels: {
						boxWidth: 40,
						font: {
							size: 18,
							weight: 'bold',
						},
					},
				},
			},
		};
	},
	mounted() {
		this.loadChart();
	},
	methods: {
		...mapGetters(['getSuspectsAndWanted']),
		loadChart() {
			const dataObject = this.getSuspectsAndWanted();
			let total = 0;

			Object.keys(dataObject).forEach(key => {
				total += dataObject[key];
			});

			const data = [];

			Object.keys(dataObject).forEach(key => {
				data.push(Math.round((dataObject[key] / total) * 100));
			});

			this.chartData.datasets[0].data = data;
			this.$refs.pieChart.loadChart();
		},
	},
	computed: {
		suspects() {
			return this.getSuspectsAndWanted().suspectsCount;
		},
		wanted() {
			return this.getSuspectsAndWanted().wantedCount;
		},
	},
	watch: {
		suspects() {
			this.loadChart();
		},
		wanted() {
			this.loadChart();
		},
	},
};
</script>

<style scoped>
.color {
	background-color: #dfeeea;
	opacity: 0.95;
}

.pieTitle {
	color: #38919b;
}
</style>
